//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "arbiter.h"
#include <utility/xmlhelper.h>
#include <assert.h>

Arbiter::Arbiter(const DOMElement* scope) : XMLElement(scope)
{
	my_state.forgot = true;
	my_state.accepted = true;
	
	inputs = NULL;
}

inline void Arbiter::setInputs(const std::vector<Wire*>* inp) {
	inputs = inp;

}

const std::vector<Wire*>* Arbiter::Inputs() {
	return inputs;
}

void Arbiter::Schedule(std::vector<Wire*> ins) {
	if (my_state.forgot && my_state.accepted) {
		schedule(ins);
		my_state.forgot = false;
		my_state.accepted = false;
	}
	else {
		if (!my_state.forgot)
			std::cerr << "WARNING: (FIXED): Arbiter::Schedule: You need to call forget() before schedule()\n\t I will do it for you." << std::endl;
		if (!my_state.accepted) {
			std::cerr << "ERROR: (PROG): Arbiter::Schedule: You need to call accept() before schedule()" << std::endl;
			exit(1);
		}
	}
} 

void Arbiter::Forget() {
	forget();
	my_state.forgot = true;
}

void Arbiter::Accept(const std::vector<Wire*>& accepted_list) {
	accept(accepted_list);
	my_state.accepted = true;
}
