//
// C++ Interface: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef DEADLINEARBITER_H
#define DEADLINEARBITER_H

#include <arbiter.h>
#include <environment/prng.h>
#include <packet.h>

#include <component.h>
#include <cassert>
#include <node.h>
#include <macros.h>

/**
@author Arvid Walter
*/
class DeadlineArbiter : public Arbiter
{
public:
        DeadlineArbiter(const DOMElement* scope=NULL);

        ~DeadlineArbiter();

        bool init(const DOMElement* scope=NULL);

        Wire* pop();
        
	Wire* front() const;
	
private:
        const void accept(const std::vector< Wire * >& accepted_list);
        const void forget();
        void schedule(std::vector< Wire * > ins);


        class CompareProperty
        {
        public:
         bool operator()(Wire* q, Wire* p)
                {
			assert(q->From()->rtti() == Component::BUFFER);
			assert(p->From()->rtti() == Component::BUFFER);

			const Flit* qFlit = q->getFlit();
			const Flit* pFlit = p->getFlit();

                        if (!qFlit || !pFlit)
				_ERROR("Cannot schedule NULL-packet");

                        if (pFlit->Owner()->deadline == qFlit->Owner()->deadline)
                                // statstically not correct, cause of 0.5
                                if  ( UniformDouble_0() < 0.5 )
                                        return false;
                                else
                                        return true;
                        return (qFlit->Owner()->deadline > pFlit->Owner()->deadline);
                };
        };

        std::priority_queue < Wire*, std::vector<Wire *> , CompareProperty>* lfuList;
};

#endif

