//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "fixedarbiter.h"
#include <simulation.h>

REGISTER_ELEMENT(FixedArbiter, "FixedOrder")

FixedArbiter::FixedArbiter(const DOMElement* scope)
                : Arbiter(scope)
{}

FixedArbiter::~FixedArbiter()
{}

bool FixedArbiter::init(const DOMElement* scope)
{
        return true;
}

// Important! Ensure the ins come in fixed order
void FixedArbiter::schedule(std::vector<Wire*> ins)
{
	if (!scheduleList.empty()) {
		std::cerr << "WARNING (NOP) : FixedArbiter::schedule : my internal list of schedule objects was not empty." << std::endl;
		forget();
	}

        // todo, ueberfluessig, ein anhaengen sollte reichen
        for (unsigned int i = 0; i < ins.size(); i++)
                scheduleList.push_back(ins[i]);

        /*if (S.priorityused)
                scheduleList.sort();*/
}

inline Wire* FixedArbiter::pop() {
	if (scheduleList.empty())
		return NULL;

	Wire* out = scheduleList.front();
	scheduleList.pop_front();
	return out;
	
}

inline Wire* FixedArbiter::front() const
{
	if (scheduleList.empty())
		return NULL;

	return scheduleList.front();
}

inline const void FixedArbiter::forget() {
	scheduleList.clear();
}
