//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "localroundrobinarbiter.h"
#include <simulation.h>

REGISTER_ELEMENT(LocalRoundRobinArbiter, "RoundRobinLocal")

LocalRoundRobinArbiter::LocalRoundRobinArbiter(const DOMElement* scope): Arbiter(scope)
{
	lastSwitched = NULL;
	SchedVar0 =0;
	SchedVar1 =0;
}


LocalRoundRobinArbiter::~LocalRoundRobinArbiter()
{
}


bool LocalRoundRobinArbiter::init(const DOMElement* scope)
{
	return true;
}

void LocalRoundRobinArbiter::schedule(std::vector<Wire*> ins)
{
	if (!Inputs()) {
		std::cerr << "ERROR (FATAL) : LocalRoundRobinArbiter::schedule : Inputs missing" << std::endl;
		exit(1);
	}

        // zuerst prfen, ob wir das erste mal diesen Tick laufen, wenn ja,
        // Variable, die die Reihenfolge bestimmt, auf den nchsten Eingang setzen
        if (SchedVar0 != Tick()) {
                SchedVar0 = Tick();

                if (lastSwitched)
                        SchedVar1 = lastSwitched->getInIndex();

                SchedVar1++;
                // wenn wir mehr als die 'anzahl der eingaenge' haben, sind wir rum und knnen bei 0 anfangen
                if (SchedVar1 == Inputs()->size() )
                        SchedVar1 = 0;

        }

        for (unsigned int i = 0; i < Inputs()->size(); i++) {
                // wenn wir einmal rum sind von vorn, daher modulo
                int trigger = (SchedVar1 + i) % Inputs()->size();
                std::vector<Wire*>::const_iterator iter;
                iter = find (ins.begin(), ins.end(), (*Inputs())[trigger]);
                if (iter != ins.end())
                        scheduleList.push_back((*iter));
        }

        /*if (S.priorityused)
                scheduleList.sort();*/

}

const void LocalRoundRobinArbiter::accept(const std::vector<Wire*>& accepted_list)
{
	// remmeber which one really got the output
	lastSwitched = accepted_list.front();
}

inline Wire* LocalRoundRobinArbiter::pop() {
	if (scheduleList.empty())
		return NULL;

	Wire* out = scheduleList.front();
	scheduleList.pop_front();
	return out;
	
}

inline Wire* LocalRoundRobinArbiter::front() const
{
	if (scheduleList.empty())
		return NULL;

	return scheduleList.front();
}

inline const void LocalRoundRobinArbiter::forget() {
	scheduleList.clear();
}
