//
// C++ Interface: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef MRUARBITER_H
#define MRUARBITER_H

#include <arbiter.h>
#include <environment/prng.h>

/**
@author Arvid Walter
*/
class MRUArbiter : public Arbiter
{
public:
        MRUArbiter(const DOMElement* scope=NULL);

        ~MRUArbiter();

        bool init(const DOMElement* scope=NULL);

        Wire* pop();
	
        Wire* front() const;
private:
        const void accept(const std::vector< Wire * >& accepted_list);
        const void forget();
        void schedule(std::vector< Wire * > ins);

        std::vector<unsigned int> won_list; // win[i] : number of wins of i at output

        class CompareProperty
        {
        public:
                bool operator()(std::pair<Wire*, unsigned int> a, std::pair<Wire*, unsigned int> b)
                {

                        if (a.second == b.second) {
                                // statstically not correct, cause of 0.5
                                if  ( UniformDouble_0() < 0.5 )
                                        return false;
                                else
                                        return true;
                        }
                        return (a.second < b.second);
                };
        };

        std::vector<std::pair<Wire *, unsigned int> > wonList;

        std::priority_queue <std::pair<Wire *, unsigned int>,std::vector<std::pair<Wire *, unsigned int> >, CompareProperty>* lfuList;

};

#endif
