//
// C++ Interface: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef OPFARBITER_H
#define OPFARBITER_H

#include <arbiter.h>
#include <environment/prng.h>
#include <packet.h>
#include <node.h>
#include <macros.h>

#include <assert.h>

/**
@author Arvid Walter
*/
class OPFArbiter : public Arbiter
{
public:
        OPFArbiter(const DOMElement* scope=NULL);

        ~OPFArbiter();

        bool init(const DOMElement* scope=NULL);

        Wire* pop();

	Wire* front() const;

private:
        const void accept(const std::vector< Wire * >& accepted_list);
        const void forget();
        void schedule(std::vector< Wire * > ins);


        class CompareProperty
        {
        public:
                bool operator()(Wire* q, Wire* p)
                {
				assert(q->From()->rtti() == Component::BUFFER);
				assert(p->From()->rtti() == Component::BUFFER);

				const Flit* qFlit = q->getFlit();
				const Flit* pFlit = p->getFlit();
				
				if (!qFlit || !pFlit) _ERROR("No valid Flit found!", 436);
				
				if (pFlit->Owner()->createTick == qFlit->Owner()->createTick)
					// statstically not correct, cause of 0.5
					if  ( UniformDouble_0() < 0.5 ) 
						return false;
					else
						return true;
                                return (qFlit->Owner()->createTick > pFlit->Owner()->createTick);

                };
        };

        std::priority_queue < Wire*, std::vector<Wire *> , CompareProperty>* opfList;

};

#endif
