//
// C++ Interface: PriorityArbiter
//
// Description:
//
//
// Author: %{AUTHOR} <asas@cs.tu-berlin.de>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef PRIORITYARBITER_H
#define PRIORITYARBITER_H

#include <arbiter.h>
#include <environment/prng.h>
#include <packet.h>

#include <component.h>
#include <assert.h>
#include <node.h>
#include <macros.h>

/**
@author Arvid Walter
*/
class PriorityArbiter : public Arbiter
{
public:
        PriorityArbiter(const DOMElement* scope=NULL);

        ~PriorityArbiter();

        bool init(const DOMElement* scope=NULL);

        Wire* pop();
        
	Wire* front() const;
	
private:
        const void accept(const std::vector< Wire * >& accepted_list);
        const void forget();
        void schedule(std::vector< Wire * > ins);


        class CompareProperty
        {
        public:
                bool operator()(Wire* q, Wire* p)
                {
			assert(q->From()->rtti() == Component::BUFFER);
			assert(p->From()->rtti() == Component::BUFFER);

			const Flit* qFlit = q->getFlit();
			const Flit* pFlit = p->getFlit();

                        if (!qFlit || !pFlit)
				_ERROR("Cannot schedule NULL-packet");

                        if (pFlit->Owner()->priority == qFlit->Owner()->priority)
                                // statstically not correct, cause of 0.5
                                if  ( UniformDouble_0() < 0.5 )
                                        return false;
                                else
                                        return true;
                        return (qFlit->Owner()->priority < pFlit->Owner()->priority);
                };
        };

        std::priority_queue < Wire*, std::vector<Wire *> , CompareProperty>* lfuList;

};

#endif

