//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "test_dlarbiter.h"
#include <simulation.h>
#include <PacketElem.h>
#include <MaskedPacket.h>
#include <wire.h>

CPPUNIT_TEST_SUITE_REGISTRATION( Test_DeadlineArbiter );

using namespace std;

void Test_DeadlineArbiter::setUp()
{
	w1 = new Wire(8,8);
	w2 = new Wire(2,2);

        // register 1
        t_container** pRegister = (t_container**)new t_container;
        *pRegister = NULL;

        (*pRegister) = new t_container;
        (*pRegister)->packet = new MaskedPacket;
	(*pRegister)->packet->deadline = 2;
	
        // register 2
        t_container** pRegister2 = (t_container**)new t_container;
        *pRegister2 = NULL;

        (*pRegister2) = new t_container;
        (*pRegister2)->packet = new MaskedPacket;
	(*pRegister2)->packet->deadline = 10;

	w1->connectRegister(pRegister);
	w2->connectRegister(pRegister2);
        
	// test Wire-vector
        ins.push_back(w1); // inindex == outindex
        ins.push_back(w2); // inindex == outindex

        arbiter.setInputs(&ins);
        arbiter.init();
}

void Test_DeadlineArbiter::schedule_test()
{
	
        arbiter.Forget();
        arbiter.Schedule(ins);
        arbiter.Accept(ins);


        CPPUNIT_ASSERT( arbiter.pop()->getInIndex() == 8 );

}
