//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "test_lruarbiter.h"
#include <simulation.h>

CPPUNIT_TEST_SUITE_REGISTRATION( Test_LRUArbiter );

using namespace std;

void Test_LRUArbiter::setUp()
{
	// test Wire-vector
	for (unsigned int i=0; i<100; i++)
		ins.push_back(new Wire(i, i)); // inindex == outindex 
	
	arbiter.setInputs(&ins);
	arbiter.init();
}

void Test_LRUArbiter::schedule_test()
{
	
	// simuliere n takte, in jedem takt will jedesmal ein anderer eigang
	// jeder eingang aber insgesamt nur einmal ausser dem letzten
	Tick() = 0;
	for (unsigned int t=0; t<100; t++) {
		std::vector<Wire*> cmp;
		cmp.push_back(ins[t%ins.size()]);
		arbiter.Forget();
		arbiter.Schedule(cmp);
		arbiter.Accept(cmp);
		
		Simulation::_instance->_globalTick++;
	}
	
	// schedule all now
	arbiter.Forget();
	arbiter.Schedule(ins);
	arbiter.Accept(ins);

	
	CPPUNIT_ASSERT( arbiter.pop()->getInIndex() == 0 );
	
}
