#include <cppunit/TextTestRunner.h>

#include <test_lfuarbiter.h>
#include <test_lruarbiter.h>
#include <test_mfuarbiter.h>
#include <test_mruarbiter.h>
#include <test_opfarbiter.h>
#include <test_wpfarbiter.h>
#include <test_dlarbiter.h>


/*!
 * Unit-Tests fuer Arbiter.
 *
 * @author Matthias Kuehm <kuehmi@cs.tu-berlin.de>
 * @return 0 bei Erfolg, != 0 sonst
 */
int main(int argc, char** argv)
{
	CppUnit::TextTestRunner runner;

	runner.addTest( Test_LFUArbiter::suite() );
	runner.addTest( Test_LRUArbiter::suite() );
	runner.addTest( Test_MFUArbiter::suite() );
	runner.addTest( Test_MRUArbiter::suite() );
	runner.addTest( Test_OPFArbiter::suite() );
	runner.addTest( Test_WPFArbiter::suite() );
	runner.addTest( Test_DeadlineArbiter::suite() );
	runner.run();

	return !runner.run("", false);
}
