//
// File: Test_Io.cpp
// Created by: Arvid Walter <asas@cs.tu-berlin.de>
// Created on: Mon Nov 24 09:29:23 2003
//

#include <test_mfuarbiter.h>

CPPUNIT_TEST_SUITE_REGISTRATION( Test_MFUArbiter );

using namespace std;

void Test_MFUArbiter::setUp()
{
	// test Wire-vector
	for (unsigned int i=0; i<100; i++)
		ins.push_back(new Wire(i, i)); // inindex == outindex 
	
	arbiter.setInputs(&ins);
	arbiter.init();
}

void Test_MFUArbiter::schedule_test()
{
	
	// simuliere n takte, in jedem takt will jedesmal ein anderer eigang
	// jeder eingang aber insgesamt nur einmal ausser dem letzten
	for (unsigned int t=0; t<101; t++) {
		std::vector<Wire*> cmp;
		cmp.push_back(ins[t%ins.size()]);
		arbiter.Forget();
		arbiter.Schedule(cmp);
		arbiter.Accept(cmp);
	}
	
	// schedule all now
	arbiter.Forget();
	arbiter.Schedule(ins);
	arbiter.Accept(ins);
	
	CPPUNIT_ASSERT( arbiter.pop()->getInIndex() == 0 );
	
}
