//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include <wpfarbiter.h>

#include <algorithm> // for_each

REGISTER_ELEMENT(WPFArbiter, "LongestWaitingFirst")

WPFArbiter::WPFArbiter(const DOMElement* scope): Arbiter(scope)
{
	wpfList = new std::priority_queue <Wire *, std::vector<Wire *> , CompareProperty>;
}


WPFArbiter::~WPFArbiter()
{
}


bool WPFArbiter::init(const DOMElement* scope)
{
	return true;
}

const void WPFArbiter::accept(const std::vector< Wire * >& accepted_list)
{
}

void WPFArbiter::schedule(std::vector< Wire * > ins)
{
	if (!wpfList->empty()) {
		std::cerr << "WARNING (NOP) : WPFArbiter::schedule : my internal list of schedule objects was not empty." << std::endl;
		forget();
	}

	// put matching in prio_queue
	for (std::vector<Wire*>::iterator it = ins.begin(); it!=ins.end(); it++) {
		wpfList->push((*it));
	}
}

inline Wire* WPFArbiter::pop() {
	if (wpfList->empty())
		return NULL;

	Wire* out = wpfList->top();
	wpfList->pop();
	return out;
}

inline Wire* WPFArbiter::front() const
{
	if (wpfList->empty())
		return NULL;

	return wpfList->top();
}

inline const void WPFArbiter::forget() {
	delete wpfList;
	wpfList = new std::priority_queue <Wire *, std::vector<Wire *> , CompareProperty>;
}
