#ifndef __BROADCAST_DISTRIBUTION__
#define __BROADCAST_DISTRIBUTION__

#include <distribution.h>

//! Broadcast-Verteilung.
/**
 * Diese Verteilung liefert bei Aufruf von choose() immer DistElements()-1,
 * was bei Verwendung als Multicast-Verteilung zu einem Broadcast fuehrt.
 *
 * @author Matthias Kuehm <kuehmi@cs.tu-berlin.de>
 */
class BroadcastDistribution : public Distribution
{
	public:
 		//! Standard-Konstruktor.
		BroadcastDistribution() : Distribution() {}
		
		//! Implementierung der abstrakten Basisklasse XMLElement.
		/**
		 * Es wird lediglich das bergebene Argument gesetzt und true
		 * zurueckgeliefert.
		 *
		 * @param scope XML-Element zu diesem Factory-Element.
		 * @return true
		 */
          	bool init(const DOMElement* scope=NULL);

          	//! Re-Implementierung der Basisklasse Distribution.
		/**
		 * @return DistElements()-1
		 */
          	int choose();

		//! Re-Implementierung der Basisklasse Distribution.
		/**
		 * Klassisches NOP.
		 */
		void reset() {}

		//! Re-Implementierung der Basisklasse Distribution.
		/**
		 * @return 1 fr distelem==DistElements()-1, 0 sonst.
		 */
		double probability(unsigned int distelem) const;
};

#endif
