#include <probability.h>
#include <utility/xmlhelper.h>

#include <cassert>

REGISTER_ELEMENT(ProbabilityDistribution, "Probabilities")

bool ProbabilityDistribution::init(const DOMElement* scope)
{	
	std::stringstream buffer;
	std::string attribute;
	
	setScope(scope);

	// XML-Element muss gesetzt sein 
	assert(Scope());
	// Prefix muss gesetzt sein
	assert(attributePrefix());
	
	buffer << attributePrefix() << "_probabilities";
	buffer >> attribute;
	
	stringToParse = conv(Scope()->getAttribute(conv(attribute.c_str())));
	
	assert(stringToParse);
	
	parseString();
	
	return true;
}

int ProbabilityDistribution::parseString()
{
	//std::cout << stringToParse << std::endl;

	if(Initialized()) return 0;
	
	char assignment_delims[] = ";=";
	char *left = NULL;
	char *right = NULL; 
	int counter = 0;

	std::vector<double> values;
	values.resize(distelements);
	
	left = strtok(stringToParse,assignment_delims);
	
	while(left || right) 
	{	
		// lhs
		if(counter % 2 == 0)
		{
			//std::cout << "-> left: "<< left << " ";

			right = strtok(NULL, assignment_delims);
		}
		// rhs
		else
		{
			double value = atof(right);
			
			//std::cout << "right: " << value << std::endl;

			if(!strcmp(left,"all"))
			{
				for(unsigned int i=0; i<values.size(); i++)
					values[i] = value;
			}
			else
			{
				IndexMap::iterator it = indexmap.find(left);
				if(it != indexmap.end())
				{
					assert(it->second < values.size());
					
					values[it->second] = value;
				}
				else
				{
					_WARNING("Ignoring unknown element " << left << "!");
				
					for(IndexMap::iterator i=indexmap.begin(); i!=indexmap.end(); i++)
					{
						std::cerr << "->Entries: " << i->first << " "; 
					}
					std::cerr << std::endl;
				}
			}
					
			left = strtok(NULL, assignment_delims);
			right = NULL;
		}
		counter++;
	}
	
	initArray(values);

	return 0;
}


