#ifndef __UNICAST_DISTRIBUTION__
#define __UNICAST_DISTRIBUTION__

#include <distribution.h>

//! Unicast-Verteilung.
/**
 * Diese Verteilung liefert bei Aufruf von choose() immer 0,
 * was bei Verwendung als Multicast-Verteilung zu einem Unicast fuehrt.
 *
 * @author Matthias Kuehm <kuehmi@cs.tu-berlin.de>
 */
class UnicastDistribution : public Distribution
{
	public:
 		//! Standard-Konstruktor.
		UnicastDistribution() : Distribution() {}
		
		//! Implementierung der abstrakten Basisklasse XMLElement.
		/**
		 * Es wird lediglich das bergebene Argument gesetzt und true
		 * zurueckgeliefert.
		 *
		 * @param scope XML-Element zu diesem Factory-Element.
		 * @return true
		 */
          	bool init(const DOMElement* scope=NULL);

          	//! Re-Implementierung der Basisklasse Distribution.
		/**
		 * @return 0
		 */
          	int choose();

		//! Re-Implementierung der Basisklasse Distribution.
		/**
		 * Klassisches NOP.
		 */
		void reset() {}

		//! Re-Implementierung der Basisklasse Distribution.
		/**
		 * @return 1 fr distelem==0, 0 sonst.
		 */
		double probability(unsigned int distelem) const;
};

#endif
