#include <uniform.h>
#include <environment/prng.h>

REGISTER_ELEMENT(UniformDistribution, "Uniform")

bool UniformDistribution::init(const DOMElement* scope)
{
	setScope(scope);

	return true;
}

int UniformDistribution::choose()
{
	if(id.empty()) return -1;

	last = UniformInt(0, id.size()-1);
	return id[last];	
}

void UniformDistribution::remove_last()
{
	if(last < 0) return;
	
	id.erase(id.begin()+(last));
	last=-1;
}

void UniformDistribution::reset()
{
	id.clear();
	for(unsigned int i=0; i<distElements(); i++)
		id.push_back(i);
	last=-1;
}

double UniformDistribution::probability(unsigned int distelem) const
{
	if(id.size())
	{
		std::vector<unsigned int>::const_iterator it = id.begin();
		while(it != id.end())
		{
			if(*it == distelem)
				// id.size != 0
				return (double)1/id.size();
			it++;
		}
	}
	return 0;
}


