#include<gsl/gsl_linalg.h>

void parabola(const double x_data[3], const double y_data[3], double coeff[3])
{
	int i, s;
	
	// LGS: Ac = y
	gsl_vector_const_view y = gsl_vector_const_view_array(y_data, 3);
	gsl_vector_view c = gsl_vector_view_array(coeff, 3);
	gsl_matrix *A = gsl_matrix_alloc(3,3);
	
	gsl_permutation *p = gsl_permutation_alloc(3);
	
	for(i=0; i<3; i++)
	{
		gsl_matrix_set(A, i, 0, x_data[i] * x_data[i]);
		gsl_matrix_set(A, i, 1, x_data[i]);
		gsl_matrix_set(A, i, 2, 1.0);
	}
	
	gsl_linalg_LU_decomp (A, p, &s);
	gsl_linalg_LU_solve (A, p, &y.vector, &c.vector);

	gsl_permutation_free (p);
	gsl_matrix_free(A);
}
