#include <cmath>

double periodogram(double n, unsigned int N, const double *X)
{
	double rsum=0.0, isum=0.0;
	for(unsigned int j=0; j<N; j++)
	{
		double exponent = - (2.0 * M_PI * j * n) / (double)N;
		rsum += X[j] * cos(exponent);
		isum += X[j] * sin(exponent);
	}
	return (rsum*rsum + isum*isum) / (double)N;
}

void periodograms(unsigned int k, unsigned int N, const double *X, double *P)
{
	for(unsigned int n=1; n<=k; n++)
	{
		P[n-1] = periodogram((double)n, N, X);
	}
}

