#include <test_mathematics.h>
#include <mathematics.h>

#include <iostream>
#include <cmath>

CPPUNIT_TEST_SUITE_REGISTRATION( Test_Mathematics );

void Test_Mathematics::setUp()
{

}

void Test_Mathematics::tearDown()
{

}

void Test_Mathematics::parabola_check()
{
	int i;
	double coeff[3];
	  
	double x1_data[] = {-1.0, 0.0, 1.0};
	double y1_data[] = { 1.0, 0.0, 1.0};
	double c1_data[] = { 1.0, 0.0, 0.0};
	
	double x2_data[] = {-4.0, 0.0, 8.0};
	double y2_data[] = {-28.125, -2.125, 1.875};
	double c2_data[] = {-0.5, 4.5, -2.125};
	
	parabola(x1_data, y1_data, coeff);

	for(i=0; i<3; i++)
	{	
		CPPUNIT_ASSERT(c1_data[i] == coeff[i]);
	}	
	
	parabola(x2_data, y2_data, coeff);

	for(i=0; i<3; i++)
	{
		CPPUNIT_ASSERT(c2_data[i] == coeff[i]);
	}
}

void Test_Mathematics::leastSquares_check()
{
	double x[] = {1.22, 2.51, 4.14, 4.73, 6.81, 6.87, 7.62, 8.59, 10.85, 12.65};
	double y[] = {3.434, 4.174, 5.239, 6.517, 4.812, 10.61, 8.918, 7.141, 11.723};
	double a[] = {-0.75, 2.48, -0.17};
	
	unsigned int n=10;
	unsigned int d=2;
	
	double a1[d+1];
	double a2[d+1];
	double C[(d+1)*n];

	leastSquares(x,y,n,d,a1);
	leastSquares(x,y,n,d,a2,C);
	
	for(unsigned int i=0; i<d+1; i++)
	{
		//std::cerr << a[i] << " = " << a1[i] << " = " << a2[i] << std::endl;
	
		CPPUNIT_ASSERT(fabs(a[i]-a1[i]) < 1.0e-2);
		CPPUNIT_ASSERT(fabs(a[i]-a1[i]) < 1.0e-2);
		CPPUNIT_ASSERT(fabs(a1[i]-a2[i]) < 1.0e-6);
	}
}
