#include <test_psquarequantile.h>
#include <psquarequantile.h>

#include <iostream>
#include <cmath>

CPPUNIT_TEST_SUITE_REGISTRATION( Test_PSquareQuantile );

void Test_PSquareQuantile::setUp()
{
	psq1 = new PSquareQuantile(0.5);
	psq2 = new PSquareQuantile(0.25);
	psq3 = new PSquareQuantile(0.75);
}

void Test_PSquareQuantile::tearDown()
{
	delete psq1;
	delete psq2;
	delete psq3;
}

void Test_PSquareQuantile::median_check()
{
	applyExample1(psq1);

	CPPUNIT_ASSERT(fabs(psq1->quantile() - 4.44) < 1.0e-2);
}

void Test_PSquareQuantile::lowerQuartile_check()
{
	applyExample1(psq2);

	CPPUNIT_ASSERT(fabs(psq2->quantile() - 0.26) < 1.0e-2);
}

void Test_PSquareQuantile::upperQuartile_check()
{
	applyExample1(psq3);
	
	CPPUNIT_ASSERT(fabs(psq3->quantile() - 18.03) < 1.0e-2);
}

void Test_PSquareQuantile::applyExample1(PSquareQuantile* psq)
{
	psq->advance(0.02);
	psq->advance(0.15);
	psq->advance(0.74);
	psq->advance(3.39);
	psq->advance(0.83);
	psq->advance(22.37);
	psq->advance(10.15);
	psq->advance(15.43);
	psq->advance(38.62);
	psq->advance(15.92);
	psq->advance(34.60);
	psq->advance(10.28);
	psq->advance(1.47);
	psq->advance(0.40);
	psq->advance(0.05);
	psq->advance(11.39);
	psq->advance(0.27);
	psq->advance(0.42);
	psq->advance(0.09);
	psq->advance(11.37);
}
