#ifndef __CINPARSERENV_H__
#define __CINPARSERENV_H__

#include <environment.h>

//! Laufzeitumgebung fuer XML-Parser.
/*!
 * Die Laufzeitumgebung fuer den XML-Parser von CINSim stellt lediglich
 * die geparsten Informationen von Kommandozeile und Konfigurationsdatei
 * bereit.
 * 
 * @see Environment
 *
 * @author Matthias Kuehm <kuehmi@cs.tu-berlin.de>
 */
class CINParserEnv : public Environment
{
	
protected:	

	//! Implementierung der abstrakten Klasse Environment.
	/*!
	 * Keine weitere Initialisierung notwendig.
	 * 
	 * @see Environment
	 */
	virtual bool initialize() 
	{
		return true;
	}

	//! Implementierung der abstrakten Klasse Environment.
	/*!
	 * Kein Zuruecksetzen notwendig.
	 *
	 * @see Environment.
	 */
	virtual bool finalize() 
	{ 
		return true; 
	}	
	
	//! Implementierung der abstrakten Klasse Environment.
	/*!
	 *
	 * @see Environment.
	 */
	virtual CmdParser* createCmdParser() const;
};

#endif
