#include <errhandler.h>

#include <iostream>

// Fehlerbehandlung
void ErrHandler::warning(const SAXParseException& e)
{
	XERCES_STD_QUALIFIER 
	cout << "\nWarning at file " << XMLString::transcode(e.getSystemId())
		 << ", line " << e.getLineNumber()
		 << ", char " << e.getColumnNumber()
		 << "\n  Xerces-Message: " << XMLString::transcode(e.getMessage()) 
		 << XERCES_STD_QUALIFIER endl;

	fErrCount++;
}

void ErrHandler::error(const SAXParseException& e)
{
	XERCES_STD_QUALIFIER 
	cout << "\nValidation Error at file " << XMLString::transcode(e.getSystemId())
		 << ", line " << e.getLineNumber()
		 << ", char " << e.getColumnNumber()
		 << "\n  Xerces-Message: " << XMLString::transcode(e.getMessage()) 
		 << XERCES_STD_QUALIFIER endl;

	fErrCount++;
}

void ErrHandler::fatalError(const SAXParseException& e)
{
	XERCES_STD_QUALIFIER 
	cout << "\nSyntax Error at file " << XMLString::transcode(e.getSystemId())
		 << ", line " << e.getLineNumber()
		 << ", char " << e.getColumnNumber()
		 << "\n  Xerces-Message: " << XMLString::transcode(e.getMessage()) 
		 << XERCES_STD_QUALIFIER endl;

	fErrCount++;
}

void ErrHandler::checkError(const SAXParseException& e)
{
	XERCES_STD_QUALIFIER 
	cout << "\nCheck Error at file " << XMLString::transcode(e.getSystemId())
		 << ", line " << e.getLineNumber()
		 << ", char " << e.getColumnNumber()
		 << "\n  Message: " << XMLString::transcode(e.getMessage())
		 << XERCES_STD_QUALIFIER endl;
	
	fErrCount++;
}

void ErrHandler::unknownError(const SAXParseException& e)
{
	XERCES_STD_QUALIFIER 
	cout << "\nUnknown Error at file " << XMLString::transcode(e.getSystemId())
	     << ", line " << e.getLineNumber()
	     << ", char " << e.getColumnNumber()
	     << "\n  Message: " << XMLString::transcode(e.getMessage())
	     << XERCES_STD_QUALIFIER endl;
	
	fErrCount++;
}

