#include <pluginmanager.h>
#include <iostream>

extern "C"
{
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <dlfcn.h>
}


PluginManager::PluginManager()
{}

PluginManager::~PluginManager()
{
        if (!plugin_map.empty())
                _ERROR("Destructing PluginManager and the plugins have not been unloaded!", 1);
}

std::vector<std::string> PluginManager::scanForPlugins(const std::string& directory)
{

        DIR *dp;
        struct dirent *entry;
        //struct stat statbuf;
        std::vector<std::string> plugins;
        std::string fullpath = directory + '/';
        if ((dp = opendir(directory.c_str())) == NULL) {
                _ERROR("Cannot open plugin directory: " + directory, 1);
                return plugins;
        }
        //chdir(dir);
        while ((entry = readdir(dp)) != NULL) {
                char* file = entry->d_name;
                struct stat statbuf;
                lstat(file, &statbuf);
                if (strcmp(entry->d_name,".") == 0 || strcmp(entry->d_name,"..") == 0 ) {
                        continue;
                }
                //if(S_ISLNK(statbuf.st_mode) || S_ISREG(statbuf.st_mode)) {
                if(!S_ISLNK(statbuf.st_mode)) {
                        // Only pickup .so files.
                        std::string sname = fullpath + std::string(entry->d_name);
                        //if (sname.find('.so')) {
                        //   cout << "Plugin! " << sname << endl;
                        //   plugins.push_back(sname);
                        // }
                        if (dlopen(sname.c_str(), RTLD_LAZY) != NULL) {
                                plugins.push_back(sname);
                        } else {
                                //std::cerr << "Cannot open " << sname << " : " << dlerror() << std::endl;
                                dlerror();
                        }
                }
        }
        closedir(dp);
        return plugins;
}


void PluginManager::print()
{
        std::map<std::string,plugin_info>::iterator it = plugin_map.begin();
        for (; it != plugin_map.end(); it++) {
                std::cout << "Plugin " << it->first << std::endl;
        }
}
