#include <cmrg.h>

#include <cassert>

REGISTER_ELEMENT(CMRG, "CMRG")

CMRG::CMRG()
{
	stream = RngStream_CreateStream(NULL);
	RngStream_IncreasedPrecis(stream, 1);
}

CMRG::~CMRG()
{
	RngStream_DeleteStream(&stream);
}

void CMRG::uniqueStreamId(unsigned int uid)
{
	// man wei ja nie...
	assert(stream);

	// Fuer mehrfache Aufrufe
	RngStream_ResetStartStream(stream);
	
	// Beginn des Streams um uid*2^127 verschieben
	for(unsigned int k=0; uid; uid>>=1, k++)
	{
		// lsb gesetzt
		if(uid & 1)
			RngStream_AdvanceState(stream, 127+k, 0);
	}
}

unsigned int CMRG::uniformInt(unsigned int start, unsigned int end)
{
	// man wei ja nie..
	assert(stream);
	assert(start<=end);
	
	// gleiche Funktionalitaet wie RngStream_RandInt, aber ein Funtionsaufruf weniger
	return start + (unsigned int) ((end-start + 1.0) * RngStream_RandU01(stream));
}

