#include <mtwister.h>

#include <cassert>

REGISTER_ELEMENT(MTwister, "MTwister")

#define WORDSIZE 32
#define PERIOD 521  // mersenne prime
#define MT_SEED 4357
#define DC_SEED 6517

#define MAXRANDOM 4294967295.0 // 2^WORDSIZE

MTwister::MTwister()
{
	init_dc(DC_SEED);
	
	mtwister = get_mt_parameter_id(WORDSIZE, PERIOD, 0);
	
	sgenrand_mt(MT_SEED, mtwister);
}

MTwister::~MTwister()
{
	free_mt_struct(mtwister);
}

void MTwister::uniqueStreamId(unsigned int uid)
{
	// man wei ja nie...
	assert(mtwister);

	free_mt_struct(mtwister);
	
	init_dc(DC_SEED);

	mtwister = get_mt_parameter_id(WORDSIZE, PERIOD, uid % 65536);

	sgenrand_mt(MT_SEED, mtwister);
}

unsigned int MTwister::uniformInt(unsigned int start, unsigned int end)
{
	// man wei ja nie..
	assert(mtwister);
	assert(start<=end);
	
	return start + (unsigned int)((end-start+1.0) * ((double)genrand_mt(mtwister)/(MAXRANDOM+1.0)));
}

