#ifndef __TEST_MTWISTER_H__
#define __TEST_MTWISTER_H__

#include <environment/prng/test_prng.h>

using namespace CppUnit;

/*! 
 * Unit-Tests fuer Mersenne Twister Dynamic Creator.
 *
 * @author Matthias Kuehm <kuehmi@cs.tu-berlin.de>
 */
class Test_MTwister : public Test_PRNG
{	
CPPUNIT_TEST_SUITE( Test_MTwister );
CPPUNIT_TEST( reproduce_check );
CPPUNIT_TEST( badargs_check );
CPPUNIT_TEST( generate_check );
CPPUNIT_TEST_SUITE_END();
	
public:

	//! Implementierung der Klasse TestFixture. 
	void setUp();

	//! Implementierung der Klasse Test_PRNG.
	std::string factoryId() { return "MTwister"; }

	//! Implementierung der Klasse Test_PRNG.
	std::string dataPrefix() { return "mtwister_"; }		
};

#endif
