#ifndef __TEST_PRNG_H__
#define __TEST_PRNG_H__

#include <cppunit/extensions/HelperMacros.h>
#include <vector>

#include <environment/prng.h>
#include <utility/factory.h>

using namespace CppUnit;

/*! 
 * Basisklasse fuer Unit-Tests fuer Generatoren von (Pseudo)Zufallszahlen.
 *
 * @author Matthias Kuehm <kuehmi@cs.tu-berlin.de>
 */
class Test_PRNG : public TestFixture
{	
CPPUNIT_TEST_SUITE( Test_PRNG );
CPPUNIT_TEST( init_check );
CPPUNIT_TEST_SUITE_END();

public:

	//! Implementierung der Klasse TestFixture.
	void tearDown();

	//! Identifier fuer Factory.
	virtual std::string factoryId() { return "Foo"; }

	//! Praefix fuer Ausgabedatei.
	virtual std::string dataPrefix() { return "Bar"; }
	
	//! Test der Initialisierung ueber Factory.
	void init_check();

	//! Test der Reproduzierbarkeit eines Streams.
	void reproduce_check();
	
	//! Test fuer Argumente.
	void badargs_check();
	
	//! Zufallszahlen mit verschiedenen Randbedingungen und zufaelliger Id.
	void generate_check();

protected:

	//! Test-Instanz.
	PRNG* prng;
};


#endif
