#ifndef __TEXTOUTPUT__
#define __TEXTOUTPUT__

#include <output/interface.h>

//! Text-Ausgabe fuer Simulationssequenzen.
/*!
 * Diese Klasse implementiert das Template OutputInterface<T> fuer
 * Ergebnisse vom Typ double und erzeugt Text-Ausgaben der Mittelwerts
 * fuer jede einzelne Messung (Variable). Die Ausgabe erfolgt nur ueber
 * den spezifizierten Stream.
 */
class TextOutput : public OutputInterface<double>
{
	public:
        
		//! Konstruktor.
		/*!
		 * Es werden das DOM-Dokument und der Ausgabe-Stream initialisiert.
		 * 
		 * @param doc Das DOM-Dokument zur Simulationsbeschreibung.
		 * @param ostream Stream fuer Ausgaben.
		 */
		TextOutput(const DOMDocument* doc, std::ostream* ostream) 
			: OutputInterface<double>(doc,ostream) {}

		//! Implementierung der Basisklasse OutputInterface<double>.
		void generate();
};

#endif
