#include <vctflit.h>
#include <vctpacket.h>
#include <assert.h>

void VCTFlit::rejected()
{
	// Nur Heads duefen zurueckgewiesen werden!
	assert(head());

	// Head wurde blockiert; Warten bis komplettes
	// Paket eingepuffert wurde (StoreAndForward)
	forward=false;
}

bool VCTFlit::moveable() const
{
	if(head() && !forward)
	{		
		// Head kann erst weiter vermittelt werden, wenn
		// puffern des Paketes abgeschlossen, d.h. wenn
		// Head und Tail im gleichen Puffer liegen
		return location == owner->back()->Location();
	}
	return true;
}

void VCTFlit::buffered(Buffer* where, signed int since)
{
	Flit::buffered(where, since);
	forward=true;
}

Flit* VCTFlit::clone() const
{
	return new VCTFlit(*this);
}

