#include <geometric.h>
#include <utility/xmlattribute.h>
#include <environment/prng.h>
#include <macros.h>

REGISTER_ELEMENT(GeometricDistribution, "Geometric")

bool GeometricDistribution::init(const DOMElement* scope)
{
	if(scope)
		setScope(scope);

	if(!Scope())
		_ERROR("Cannot initialize traffic distribution without its XML element!");

	load = getAttribute("load");
	constPacketSize = getAttribute("packetSize", getParent());

	if(load < 0.0 || load > 1.0)
		_ERROR("[GeometricDistribution] Load (" << load << ") out of range!");
	
	return true;
}


inline bool GeometricDistribution::ifNowGenerate(unsigned int)
{
	double flit_load = -(load/ (-load-((double)constPacketSize)+((double)constPacketSize)*load));
	return (flit_load >= UniformDouble_01());
}

