#include <periodic.h>
#include <utility/xmlattribute.h>
#include <macros.h>

REGISTER_ELEMENT(PeriodicDistribution, "Periodic")

bool PeriodicDistribution::init(const DOMElement* scope)
{
	if(scope)
		setScope(scope);
	
	if(!Scope())
		_ERROR("Cannot initialize traffic distribution without its XML element!");

	offset = getAttribute("offset");
	modulo = getAttribute("modulo");

	if(!modulo)
	{
		_WARNING("Specified modulo is zero! Will use modulo one instead.");
		modulo=1;
	}

	return true;
}

inline bool PeriodicDistribution::ifNowGenerate(unsigned int)
{
	unsigned int current = tick++;
	return ((current>=offset) && !((current-offset)%modulo));
}

