#include <random.h>
#include <environment/prng.h>


RandomKofN::RandomKofN(t_Index anN)
// offset 1
{
        t_Index i;

        itsArray = new t_Index[anN];
        for (i=1;i<=anN;i++)
        {
                itsArray[i-1] = i;
        }
        itsN = anN;
        itsArrayLen = anN;
}

t_Index RandomKofN::Choose()
{
        t_Index k,j,r;

        /*
         * Choose an element of the array, take its value
         */
        double rand;
        k = (t_Index)((rand=UniformDouble_0())*itsArrayLen);
        r = itsArray[k];

        /*
         * The chosen element has gone, the array elements
         * on the right must be moved one to the left
         */
        for (j=k+1;j<itsArrayLen;j++) {
                itsArray[j-1] = itsArray[j];
        }
        itsArrayLen--;

        return r;
}

t_bool RandomKofN::Empty()
// OUT: all numbers are chosen
{
        return (itsArrayLen == 0);
}

RandomKofN::~RandomKofN()
{
        delete[] itsArray;
}


RandomKofList::RandomKofList()
{
}

void RandomKofList::Insert(t_Index anElem)
// PRE: Insert was called <= aMaxListLen-1
{
        itsList.push_back(anElem);
}

t_Index RandomKofList::Choose()
{
        t_Index k,r;

        /*
         * Choose an element of the array, take its value
         */
        double rand;
        k = (t_Index)((rand=UniformDouble_0())*itsList.size());
        r = itsList[k];

        /*
         * The chosen element has gone, the array elements
         * on the right must be moved one to the left
         */
        itsList[k] = itsList.back();
        itsList.pop_back();

        return r;
}

t_bool RandomKofList::Empty()
// OUT: all numbers are chosen
{
        return (!itsList.size());
}

RandomKofList::~RandomKofList()
{}


Random1ofList::Random1ofList(t_Index aMaxListLen)
{
        itsList = new t_Index[aMaxListLen];
        itsListLen = 0;
}

void Random1ofList::Insert(t_Index anElem)
// PRE: Insert was called <= aMaxListLen-1
{
        itsList[itsListLen] = anElem;
        itsListLen++;
}

t_Index Random1ofList::Choose()
{
        t_Index k;

        k = (t_Index)(UniformDouble_0()*itsListLen);
        return itsList[k];
}

Random1ofList::~Random1ofList()
{
        delete[] itsList;
}

