#include <valuestring.h>
#include <macros.h>
#include <sstream>

ValueString::ValueString(const std::string& value)
{
	real_string = false;
	negative = false;
	
	setString(value);
}

void ValueString::setString(const std::string& value)
{
	m_str = value;

	if (m_str != snull) 
	{
		unsigned int ip = 0;
		bool komma = false;

		if(m_str.at(0)=='-')
		{
			negative=true;
			ip++;
		}
		if(m_str.at(0)=='+')
			ip++;
		
		while ( ip < m_str.size() ) 
		{
			// auf komma testen
			// TODO: ist komma am anfang oder am ende erlaubt ? ich glaube ja.
			if ((m_str.at(ip) == '.' || m_str.at(ip) == ',') && !komma)
				komma = true; //vorkommen des kommas merken
			else if (!isdigit(m_str.at(ip))) {
				real_string = true;
			}
			++ip;
		}
	}
}

ValueString::operator double() const
{
	if (real_string)
		_ERROR("Invalid cast (double)" << m_str << "!");
	
	if (m_str == snull)
		return (double)pnull;

	std::stringstream sstr;
	sstr << m_str;
	double result;
	sstr >> result;
	return result;
}

ValueString::operator int() const
{
	if (real_string)
		_ERROR("Invalid cast (int)" << m_str << "!");
	
	if (m_str == snull)
		return (int)pnull;

	std::stringstream sstr;
	sstr << m_str;
	int result;
	sstr >> result;
	return result;
}
	
ValueString::operator uint() const
{
	if (real_string || negative)
		_ERROR("Invalid cast (uint)" << m_str << "!");
	
	if (m_str == snull)
		return (uint)pnull;

	std::stringstream sstr;
	sstr << m_str;
	int result;
	sstr >> result;
	return result;
}

