#include <wirematrixiterator.h>
#include <wirematrixentry.h>

#include <assert.h>


int WireMatrixIterator::set(ModifierList* modifiers)
{	
	for(ModifierList::iterator mi = modifiers->begin(); mi != modifiers->end(); mi++)
	{		
		set(*mi);
	}
	return 1;
}

int WireMatrixIterator::set(WireMatrixModifier* wmm)
{
	int result = wmm->precondition(this);
	
	if(result == WireMatrixModifier::PASSED)
		wmm->modify(this);

	return result;
}

int WireMatrixIterator::setAll(ModifierList* modifiers)
{
	reset();
	
	while(hasNext())
	{
		next();
		set(modifiers);
	}
	return 1;
}

int WireMatrixIterator::setAll(WireMatrixModifier* wmm)
{
	reset();

	while(hasNext())
	{
		next();
		set(wmm);
	}
	return 1;
}

WireMatrixIterator* InWireIterator::crossingIterator()
{	
	// Annahme: Iterator verfuegbar.
	assert(value().getInWire()->getInIndex() < cross_iterators.size());
	// Annahme: Kreuzender Iterator
	assert(cross_iterators[value().getInWire()->getInIndex()]->rtti() != rtti());

	return cross_iterators[value().getInWire()->getInIndex()];
}

WireMatrixIterator* OutWireIterator::crossingIterator()
{	
	// Annahme: Iterator verfuegbar.
	assert(value().getOutWire()->getOutIndex() < cross_iterators.size());
	// Annahme: Kreuzender Iterator
	assert(cross_iterators[value().getInWire()->getInIndex()]->rtti() != rtti());

	return cross_iterators[value().getOutWire()->getOutIndex()];
}
