#include <xmlload.h>
#include <environment.h>
#include <macros.h>

#include <string>
#include <iostream>

const SchemaInformation* XmlLoad::_schemaInformation = NULL;
const DOMDocument* XmlLoad::_document = NULL;

using namespace std;

void XmlLoad::load()
{
	static CINParser* parser = new CINParser();

	//
	// Dokument einmal parsen
	//
	if(!_document)
	{
		// parsen und auf Fehler testen
		string xmlfile = Env()->getValue(_XML_INPUT_);
		if (xmlfile == snull) 
		{
			_ERROR("No input file specified!");
		}
	
		if(!parser->parseFile(xmlfile.c_str())) 
		{
			cerr << "\nErrors occured while parsing XML-File: " << xmlfile << endl;
			exit(1);
		}

		_document = parser->getDocument();
		_schemaInformation = parser->getSchemaInformation();
	}
	
	//
	// Initialisierung anhand von DOM-Baum und Schema-Informationen
	// 
    init();
}
