#include <environment.h>
#include <macros.h>

#include <environment/parser/cinparser.h>
#include <utility/valuestring.h>

#include <iostream>
#include <sstream>
#include <cassert>

using namespace std;

int main (int argc, char** argv)
{
	Environment::Setup("CINParserEnv", argc, argv);
	
	// Zeitmessung und Fehler
	long start;
	long end;
	int errors=0;

	// XML-Dokument parsen
	CINParser* cinparser = new CINParser();

	// Parsen starten und Zeit stoppen
	start = XMLPlatformUtils::getCurrentMillis();

	// parsen und auf Fehler testen
	string xmlfile = Env()->getValue(_XML_INPUT_);
	if (xmlfile == snull) 
	{
		cerr << "ERROR: I suggest you forgot to specify an input file." << endl;
		exit(1);
	}

	cinparser->parseFile(xmlfile.c_str());
	end = XMLPlatformUtils::getCurrentMillis();

	// Fehler aufsammeln
	errors += cinparser->getParseErrors();

	// Aufraeumen
	delete cinparser;

	// kurze Auswertung
	cout << "\nFinished Parsing, found " << errors << " Error(s)";

	if(Env()->isSet(_SHOW_TIME_)) 
	{
		cout << ", Duration: " << end - start << " ms";
	}
	cout << endl;

	Environment::Halt();
	
	return 0;
}
